#pragma once
#include "GLFW/glfw3.h"
#include <vector>
#include "../PerfCounter.h"

#include "Renderable.h"
#include "Memory/Framebuffer.h"
#include "../Scene/Components.h"
#include"../Scene/Scene.h"
#include "Graphics/Primitives/DrawCommand.h"

namespace YoggieEngine {

	struct RendererConfig {
		int ScreenWidth, ScreenHeight;
		glm::vec3 ClearColor;
		bool DepthTest; 
	};

	class Renderer {
	public:
		Renderer(RendererConfig& config);
		~Renderer();


		void Submit(Render3DComponent& renderComponent, TransformComponent& transform); // Collects DrawCommands
		void Render();	// Draw to screen (using drawCall structs)
	
		void setCurrentFrameBuffer(const Framebuffer& fb);
		void setClearColor(const glm::vec3& ClearColor);

		Camera& getCamera();

	private:
		Framebuffer m_framebuffer;
		glm::vec3 m_clearColor;
		bool m_depthTest;
		std::vector<DrawCommand> commands;
	};
}
